package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = true;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.shellMode) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static boolean _frontcamera = false;
public static anywheresoftware.b4a.phone.Phone.PhoneWakeState _ws = null;
public static boolean _pictureprogress = false;
public static int[] _fittingpreviewsizes = null;
public anywheresoftware.b4a.objects.PanelWrapper _panel1 = null;
public anywheresoftware.b4a.objects.PanelWrapper _panel2 = null;
public anywheresoftware.b4a.objects.PanelWrapper _panelpicture = null;
public b4a.example.cameraexclass _camex = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnpicturesize = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnflash = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _imageflashon = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _imageflashoff = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _imageflashtorch = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _imageflashauto = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btneffect = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnfocus = null;
public anywheresoftware.b4a.objects.ListViewWrapper _lvpsize = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnev = null;
public anywheresoftware.b4a.objects.ListViewWrapper _lvev = null;
  public Object[] GetGlobals() {
		return new Object[] {"Activity",mostCurrent._activity,"btnEffect",mostCurrent._btneffect,"btnEV",mostCurrent._btnev,"BtnFlash",mostCurrent._btnflash,"btnFocus",mostCurrent._btnfocus,"btnPictureSize",mostCurrent._btnpicturesize,"camEx",mostCurrent._camex,"fittingpreviewSizes",_fittingpreviewsizes,"frontCamera",_frontcamera,"ImageFlashAUTO",mostCurrent._imageflashauto,"ImageFlashOFF",mostCurrent._imageflashoff,"ImageFlashON",mostCurrent._imageflashon,"ImageFlashTORCH",mostCurrent._imageflashtorch,"lvEV",mostCurrent._lvev,"LvPSize",mostCurrent._lvpsize,"Panel1",mostCurrent._panel1,"Panel2",mostCurrent._panel2,"PanelPicture",mostCurrent._panelpicture,"PictureProgress",_pictureprogress,"WS",_ws};
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = main.mostCurrent.processBA.sharedProcessBA.activityBA.get();
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

}
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 63;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(1073741824);
 BA.debugLineNum = 64;BA.debugLine="Log(\"activity_create\")";
Debug.ShouldStop(-2147483648);
anywheresoftware.b4a.keywords.Common.Log("activity_create");
 BA.debugLineNum = 65;BA.debugLine="Activity.LoadLayout(\"1\")";
Debug.ShouldStop(1);
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 BA.debugLineNum = 66;BA.debugLine="ImageFlashON = LoadBitmap(File.DirAssets,\"icon_flash_on.png\")";
Debug.ShouldStop(2);
mostCurrent._imageflashon = anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"icon_flash_on.png");
 BA.debugLineNum = 67;BA.debugLine="ImageFlashOFF = LoadBitmap(File.DirAssets,\"icon_flash_OFF.png\")";
Debug.ShouldStop(4);
mostCurrent._imageflashoff = anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"icon_flash_OFF.png");
 BA.debugLineNum = 68;BA.debugLine="ImageFlashTORCH = LoadBitmap(File.DirAssets,\"icon_flash_TORCH.png\")";
Debug.ShouldStop(8);
mostCurrent._imageflashtorch = anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"icon_flash_TORCH.png");
 BA.debugLineNum = 69;BA.debugLine="ImageFlashAUTO = LoadBitmap(File.DirAssets,\"icon_flash_AUTO.png\")";
Debug.ShouldStop(16);
mostCurrent._imageflashauto = anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"icon_flash_AUTO.png");
 BA.debugLineNum = 72;BA.debugLine="LvPSize.Initialize(\"LvPSize\")";
Debug.ShouldStop(128);
mostCurrent._lvpsize.Initialize(mostCurrent.activityBA,"LvPSize");
 BA.debugLineNum = 74;BA.debugLine="PanelPicture.Visible = False";
Debug.ShouldStop(512);
mostCurrent._panelpicture.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 76;BA.debugLine="End Sub";
Debug.ShouldStop(2048);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 88;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(8388608);
 BA.debugLineNum = 90;BA.debugLine="camEx.CloseNow";
Debug.ShouldStop(33554432);
mostCurrent._camex._closenow();
 BA.debugLineNum = 92;BA.debugLine="End Sub";
Debug.ShouldStop(134217728);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 17;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(65536);
 BA.debugLineNum = 18;BA.debugLine="Log(\"activity resume\")";
Debug.ShouldStop(131072);
anywheresoftware.b4a.keywords.Common.Log("activity resume");
 BA.debugLineNum = 19;BA.debugLine="Try";
Debug.ShouldStop(262144);
try { BA.debugLineNum = 20;BA.debugLine="InitializeCamera";
Debug.ShouldStop(524288);
_initializecamera();
 BA.debugLineNum = 22;BA.debugLine="camEx.Release        ' <<< 2 lignes rajoutées pour palier le bug parfois au démarrage";
Debug.ShouldStop(2097152);
mostCurrent._camex._release();
 BA.debugLineNum = 23;BA.debugLine="InitializeCamera";
Debug.ShouldStop(4194304);
_initializecamera();
 } 
       catch (Exception e7) {
			processBA.setLastException(e7); BA.debugLineNum = 25;BA.debugLine="Msgbox(\"fail\", \"\")";
Debug.ShouldStop(16777216);
anywheresoftware.b4a.keywords.Common.Msgbox("fail","",mostCurrent.activityBA);
 };
 BA.debugLineNum = 28;BA.debugLine="End Sub";
Debug.ShouldStop(134217728);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btnpicturesize_click() throws Exception{
		Debug.PushSubsStack("btnPictureSize_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
b4a.example.cameraexclass._camerasize[] _picturesizes = null;
int _i = 0;
 BA.debugLineNum = 186;BA.debugLine="Sub btnPictureSize_Click";
Debug.ShouldStop(33554432);
 BA.debugLineNum = 187;BA.debugLine="Dim pictureSizes() As CameraSize = camEx.GetSupportedPicturesSizes";
Debug.ShouldStop(67108864);
_picturesizes = mostCurrent._camex._getsupportedpicturessizes();Debug.locals.put("pictureSizes", _picturesizes);Debug.locals.put("pictureSizes", _picturesizes);
 BA.debugLineNum = 190;BA.debugLine="ClearLvs";
Debug.ShouldStop(536870912);
_clearlvs();
 BA.debugLineNum = 191;BA.debugLine="LvPSize.Color = Colors.ARGB(160,0,0,0)";
Debug.ShouldStop(1073741824);
mostCurrent._lvpsize.setColor(anywheresoftware.b4a.keywords.Common.Colors.ARGB((int) (160),(int) (0),(int) (0),(int) (0)));
 BA.debugLineNum = 192;BA.debugLine="LvPSize.SingleLineLayout.ItemHeight = 25dip";
Debug.ShouldStop(-2147483648);
mostCurrent._lvpsize.getSingleLineLayout().setItemHeight(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (25)));
 BA.debugLineNum = 193;BA.debugLine="LvPSize.SingleLineLayout.Label.TextSize = 15";
Debug.ShouldStop(1);
mostCurrent._lvpsize.getSingleLineLayout().Label.setTextSize((float) (15));
 BA.debugLineNum = 194;BA.debugLine="For i = 0 To pictureSizes.Length-1";
Debug.ShouldStop(2);
{
final int step120 = 1;
final int limit120 = (int) (_picturesizes.length-1);
for (_i = (int) (0); (step120 > 0 && _i <= limit120) || (step120 < 0 && _i >= limit120); _i = ((int)(0 + _i + step120))) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 195;BA.debugLine="LvPSize.AddSingleLine(pictureSizes(i).Width&\"x\"&pictureSizes(i).Height)";
Debug.ShouldStop(4);
mostCurrent._lvpsize.AddSingleLine(BA.NumberToString(_picturesizes[_i].Width)+"x"+BA.NumberToString(_picturesizes[_i].Height));
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 197;BA.debugLine="Activity.AddView(LvPSize,0, btnPictureSize.Height, 30%x, Min(80%y, (pictureSizes.Length+0.6) * 25dip))";
Debug.ShouldStop(16);
mostCurrent._activity.AddView((android.view.View)(mostCurrent._lvpsize.getObject()),(int) (0),mostCurrent._btnpicturesize.getHeight(),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (30),mostCurrent.activityBA),(int) (anywheresoftware.b4a.keywords.Common.Min(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (80),mostCurrent.activityBA),(_picturesizes.length+0.6)*anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (25)))));
 BA.debugLineNum = 199;BA.debugLine="End Sub";
Debug.ShouldStop(64);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _camera1_ready(boolean _success) throws Exception{
		Debug.PushSubsStack("Camera1_Ready (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
b4a.example.cameraexclass._camerasize[] _picturesizes = null;
float _ratio = 0f;
float _ratiopreview = 0f;
b4a.example.cameraexclass._camerasize[] _previewsizes = null;
int _i = 0;
int _imax = 0;
int _psmax = 0;
int _j = 0;
Debug.locals.put("Success", _success);
 BA.debugLineNum = 94;BA.debugLine="Sub Camera1_Ready (Success As Boolean)";
Debug.ShouldStop(536870912);
 BA.debugLineNum = 95;BA.debugLine="If Success Then";
Debug.ShouldStop(1073741824);
if (_success) { 
 BA.debugLineNum = 97;BA.debugLine="ClearLvs";
Debug.ShouldStop(1);
_clearlvs();
 BA.debugLineNum = 98;BA.debugLine="camEx.StopPreview";
Debug.ShouldStop(2);
mostCurrent._camex._stoppreview();
 BA.debugLineNum = 99;BA.debugLine="camEx.SetJpegQuality(90)";
Debug.ShouldStop(4);
mostCurrent._camex._setjpegquality((int) (90));
 BA.debugLineNum = 105;BA.debugLine="Dim pictureSizes() As CameraSize = camEx.GetSupportedPicturesSizes";
Debug.ShouldStop(256);
_picturesizes = mostCurrent._camex._getsupportedpicturessizes();Debug.locals.put("pictureSizes", _picturesizes);Debug.locals.put("pictureSizes", _picturesizes);
 BA.debugLineNum = 108;BA.debugLine="Dim ratio As Float";
Debug.ShouldStop(2048);
_ratio = 0f;Debug.locals.put("ratio", _ratio);
 BA.debugLineNum = 109;BA.debugLine="Dim ratioPreview As Float";
Debug.ShouldStop(4096);
_ratiopreview = 0f;Debug.locals.put("ratioPreview", _ratiopreview);
 BA.debugLineNum = 111;BA.debugLine="Dim previewSizes() As CameraSize = camEx.GetSupportedPreviewSizes";
Debug.ShouldStop(16384);
_previewsizes = mostCurrent._camex._getsupportedpreviewsizes();Debug.locals.put("previewSizes", _previewsizes);Debug.locals.put("previewSizes", _previewsizes);
 BA.debugLineNum = 112;BA.debugLine="For i = 0 To previewSizes.Length - 1";
Debug.ShouldStop(32768);
{
final int step64 = 1;
final int limit64 = (int) (_previewsizes.length-1);
for (_i = (int) (0); (step64 > 0 && _i <= limit64) || (step64 < 0 && _i >= limit64); _i = ((int)(0 + _i + step64))) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 113;BA.debugLine="Log(TAB & previewSizes(i).Width & \"x\" & previewSizes(i).Height & \" \" & (previewSizes(i).Width / previewSizes(i).Height) )";
Debug.ShouldStop(65536);
anywheresoftware.b4a.keywords.Common.Log(anywheresoftware.b4a.keywords.Common.TAB+BA.NumberToString(_previewsizes[_i].Width)+"x"+BA.NumberToString(_previewsizes[_i].Height)+" "+BA.NumberToString((_previewsizes[_i].Width/(double)_previewsizes[_i].Height)));
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 115;BA.debugLine="Log(\"------------\")";
Debug.ShouldStop(262144);
anywheresoftware.b4a.keywords.Common.Log("------------");
 BA.debugLineNum = 116;BA.debugLine="Dim imax As Int";
Debug.ShouldStop(524288);
_imax = 0;Debug.locals.put("imax", _imax);
 BA.debugLineNum = 117;BA.debugLine="Dim psmax As Int = 0";
Debug.ShouldStop(1048576);
_psmax = (int) (0);Debug.locals.put("psmax", _psmax);Debug.locals.put("psmax", _psmax);
 BA.debugLineNum = 118;BA.debugLine="For i = 0 To pictureSizes.Length-1   ' boucle recherche taille max";
Debug.ShouldStop(2097152);
{
final int step70 = 1;
final int limit70 = (int) (_picturesizes.length-1);
for (_i = (int) (0); (step70 > 0 && _i <= limit70) || (step70 < 0 && _i >= limit70); _i = ((int)(0 + _i + step70))) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 119;BA.debugLine="Log(TAB & pictureSizes(i).Width & \"x\" & pictureSizes(i).Height & \" \" & (pictureSizes(i).Width / pictureSizes(i).Height) )";
Debug.ShouldStop(4194304);
anywheresoftware.b4a.keywords.Common.Log(anywheresoftware.b4a.keywords.Common.TAB+BA.NumberToString(_picturesizes[_i].Width)+"x"+BA.NumberToString(_picturesizes[_i].Height)+" "+BA.NumberToString((_picturesizes[_i].Width/(double)_picturesizes[_i].Height)));
 BA.debugLineNum = 120;BA.debugLine="If pictureSizes(i).Width + pictureSizes(i).Height > psmax Then";
Debug.ShouldStop(8388608);
if (_picturesizes[_i].Width+_picturesizes[_i].Height>_psmax) { 
 BA.debugLineNum = 121;BA.debugLine="psmax = pictureSizes(i).Width + pictureSizes(i).Height";
Debug.ShouldStop(16777216);
_psmax = (int) (_picturesizes[_i].Width+_picturesizes[_i].Height);Debug.locals.put("psmax", _psmax);
 BA.debugLineNum = 122;BA.debugLine="imax = i";
Debug.ShouldStop(33554432);
_imax = _i;Debug.locals.put("imax", _imax);
 };
 BA.debugLineNum = 124;BA.debugLine="ratio = pictureSizes(i).Width / pictureSizes(i).Height";
Debug.ShouldStop(134217728);
_ratio = (float) (_picturesizes[_i].Width/(double)_picturesizes[_i].Height);Debug.locals.put("ratio", _ratio);
 BA.debugLineNum = 125;BA.debugLine="For j = 0 To previewSizes.Length - 1";
Debug.ShouldStop(268435456);
{
final int step77 = 1;
final int limit77 = (int) (_previewsizes.length-1);
for (_j = (int) (0); (step77 > 0 && _j <= limit77) || (step77 < 0 && _j >= limit77); _j = ((int)(0 + _j + step77))) {
Debug.locals.put("j", _j);
 BA.debugLineNum = 126;BA.debugLine="fittingpreviewSizes(i) = 0 'par défaut on prends le premier preview size OK";
Debug.ShouldStop(536870912);
_fittingpreviewsizes[_i] = (int) (0);
 BA.debugLineNum = 127;BA.debugLine="ratioPreview =  previewSizes(j).Width / previewSizes(j).Height";
Debug.ShouldStop(1073741824);
_ratiopreview = (float) (_previewsizes[_j].Width/(double)_previewsizes[_j].Height);Debug.locals.put("ratioPreview", _ratiopreview);
 BA.debugLineNum = 128;BA.debugLine="If ratioPreview = ratio Then";
Debug.ShouldStop(-2147483648);
if (_ratiopreview==_ratio) { 
 BA.debugLineNum = 129;BA.debugLine="fittingpreviewSizes(i) = j";
Debug.ShouldStop(1);
_fittingpreviewsizes[_i] = _j;
 BA.debugLineNum = 130;BA.debugLine="Exit";
Debug.ShouldStop(2);
if (true) break;
 };
 }
}Debug.locals.put("j", _j);
;
 BA.debugLineNum = 133;BA.debugLine="Log(fittingpreviewSizes(i))";
Debug.ShouldStop(16);
anywheresoftware.b4a.keywords.Common.Log(BA.NumberToString(_fittingpreviewsizes[_i]));
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 136;BA.debugLine="camEx.SetPictureSize(pictureSizes(imax).Width , pictureSizes(imax).Height)";
Debug.ShouldStop(128);
mostCurrent._camex._setpicturesize(_picturesizes[_imax].Width,_picturesizes[_imax].Height);
 BA.debugLineNum = 137;BA.debugLine="camEx.SetPreviewSize(previewSizes(fittingpreviewSizes(imax)).Width , previewSizes(fittingpreviewSizes(imax)).Height)";
Debug.ShouldStop(256);
mostCurrent._camex._setpreviewsize(_previewsizes[_fittingpreviewsizes[_imax]].Width,_previewsizes[_fittingpreviewsizes[_imax]].Height);
 BA.debugLineNum = 138;BA.debugLine="camEx.CommitParameters";
Debug.ShouldStop(512);
mostCurrent._camex._commitparameters();
 BA.debugLineNum = 142;BA.debugLine="btnEV.Text = \"+/-\" & CRLF & \"0\"";
Debug.ShouldStop(8192);
mostCurrent._btnev.setText((Object)("+/-"+anywheresoftware.b4a.keywords.Common.CRLF+"0"));
 BA.debugLineNum = 146;BA.debugLine="ratio = pictureSizes(imax).Height /pictureSizes(imax).Width";
Debug.ShouldStop(131072);
_ratio = (float) (_picturesizes[_imax].Height/(double)_picturesizes[_imax].Width);Debug.locals.put("ratio", _ratio);
 BA.debugLineNum = 147;BA.debugLine="btnPictureSize.Text = pictureSizes(imax).width&\"x\"& pictureSizes(imax).Height";
Debug.ShouldStop(262144);
mostCurrent._btnpicturesize.setText((Object)(BA.NumberToString(_picturesizes[_imax].Width)+"x"+BA.NumberToString(_picturesizes[_imax].Height)));
 BA.debugLineNum = 148;BA.debugLine="If ratio < (100%x / 100%y) Then 'crop largeur de panel  (ratio = 3/4 et y = 5 x =3 env)";
Debug.ShouldStop(524288);
if (_ratio<(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA)/(double)anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA))) { 
 BA.debugLineNum = 149;BA.debugLine="Panel1.Width =   100%y / ratio";
Debug.ShouldStop(1048576);
mostCurrent._panel1.setWidth((int) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA)/(double)_ratio));
 BA.debugLineNum = 150;BA.debugLine="Panel1.Height = 100%y";
Debug.ShouldStop(2097152);
mostCurrent._panel1.setHeight(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA));
 BA.debugLineNum = 151;BA.debugLine="Panel1.left = Abs((100%x - Panel1.width)/2)";
Debug.ShouldStop(4194304);
mostCurrent._panel1.setLeft((int) (anywheresoftware.b4a.keywords.Common.Abs((anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA)-mostCurrent._panel1.getWidth())/(double)2)));
 }else {
 BA.debugLineNum = 153;BA.debugLine="Panel1.Width = 100%x";
Debug.ShouldStop(16777216);
mostCurrent._panel1.setWidth(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA));
 BA.debugLineNum = 154;BA.debugLine="Panel1.Height = 100%x / ratio";
Debug.ShouldStop(33554432);
mostCurrent._panel1.setHeight((int) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA)/(double)_ratio));
 BA.debugLineNum = 155;BA.debugLine="Panel1.top = Abs((100%y - Panel1.height)/2)";
Debug.ShouldStop(67108864);
mostCurrent._panel1.setTop((int) (anywheresoftware.b4a.keywords.Common.Abs((anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA)-mostCurrent._panel1.getHeight())/(double)2)));
 };
 BA.debugLineNum = 158;BA.debugLine="camEx.StartPreview";
Debug.ShouldStop(536870912);
mostCurrent._camex._startpreview();
 BA.debugLineNum = 160;BA.debugLine="Log (\"panel1 wxh \" & Panel1.Width & \"x\" & Panel1.Height )";
Debug.ShouldStop(-2147483648);
anywheresoftware.b4a.keywords.Common.Log("panel1 wxh "+BA.NumberToString(mostCurrent._panel1.getWidth())+"x"+BA.NumberToString(mostCurrent._panel1.getHeight()));
 BA.debugLineNum = 161;BA.debugLine="Log(camEx.GetPreviewSize)";
Debug.ShouldStop(1);
anywheresoftware.b4a.keywords.Common.Log(BA.ObjectToString(mostCurrent._camex._getpreviewsize()));
 }else {
 BA.debugLineNum = 168;BA.debugLine="ToastMessageShow(\"Cannot open camera.\", True)";
Debug.ShouldStop(128);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Cannot open camera.",anywheresoftware.b4a.keywords.Common.True);
 };
 BA.debugLineNum = 170;BA.debugLine="End Sub";
Debug.ShouldStop(512);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _changecamera_click() throws Exception{
		Debug.PushSubsStack("ChangeCamera_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 174;BA.debugLine="Sub ChangeCamera_Click";
Debug.ShouldStop(8192);
 BA.debugLineNum = 176;BA.debugLine="frontCamera = Not(frontCamera)";
Debug.ShouldStop(32768);
_frontcamera = anywheresoftware.b4a.keywords.Common.Not(_frontcamera);
 BA.debugLineNum = 179;BA.debugLine="camEx.CloseNow";
Debug.ShouldStop(262144);
mostCurrent._camex._closenow();
 BA.debugLineNum = 180;BA.debugLine="Activity_Resume";
Debug.ShouldStop(524288);
_activity_resume();
 BA.debugLineNum = 182;BA.debugLine="End Sub";
Debug.ShouldStop(2097152);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _clearlvs() throws Exception{
		Debug.PushSubsStack("ClearLvs (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 249;BA.debugLine="Sub ClearLvs ' efface toutes les ListViews pour éviter qu'elles ne se chevauchent (une seule active à la fois)";
Debug.ShouldStop(16777216);
 BA.debugLineNum = 250;BA.debugLine="LvPSize.clear";
Debug.ShouldStop(33554432);
mostCurrent._lvpsize.Clear();
 BA.debugLineNum = 251;BA.debugLine="LvPSize.RemoveView";
Debug.ShouldStop(67108864);
mostCurrent._lvpsize.RemoveView();
 BA.debugLineNum = 253;BA.debugLine="End Sub";
Debug.ShouldStop(268435456);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 25621, new int[] {8, 15}, "72b47e44-9645-4f55-9cec-d9e318127f80");}

    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 40;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 41;BA.debugLine="Private Panel1 As Panel";
mostCurrent._panel1 = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 42;BA.debugLine="Private Panel2 As Panel";
mostCurrent._panel2 = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 43;BA.debugLine="Private PanelPicture As Panel";
mostCurrent._panelpicture = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 45;BA.debugLine="Private camEx As CameraExClass";
mostCurrent._camex = new b4a.example.cameraexclass();
 //BA.debugLineNum = 46;BA.debugLine="Dim btnPictureSize As Button";
mostCurrent._btnpicturesize = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 47;BA.debugLine="Dim BtnFlash As Button";
mostCurrent._btnflash = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 48;BA.debugLine="Dim ImageFlashON As Bitmap";
mostCurrent._imageflashon = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 49;BA.debugLine="Dim ImageFlashOFF As Bitmap";
mostCurrent._imageflashoff = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 50;BA.debugLine="Dim ImageFlashTORCH As Bitmap";
mostCurrent._imageflashtorch = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 51;BA.debugLine="Dim ImageFlashAUTO As Bitmap";
mostCurrent._imageflashauto = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 53;BA.debugLine="Dim btnEffect As Button";
mostCurrent._btneffect = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 54;BA.debugLine="Dim btnFocus As Button";
mostCurrent._btnfocus = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 55;BA.debugLine="Dim LvPSize As ListView";
mostCurrent._lvpsize = new anywheresoftware.b4a.objects.ListViewWrapper();
 //BA.debugLineNum = 56;BA.debugLine="Dim btnEV As Button";
mostCurrent._btnev = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 59;BA.debugLine="Dim lvEV As ListView";
mostCurrent._lvev = new anywheresoftware.b4a.objects.ListViewWrapper();
 //BA.debugLineNum = 61;BA.debugLine="End Sub";
return "";
}
public static String  _initializecamera() throws Exception{
		Debug.PushSubsStack("InitializeCamera (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 79;BA.debugLine="Private Sub InitializeCamera";
Debug.ShouldStop(16384);
 BA.debugLineNum = 80;BA.debugLine="Try";
Debug.ShouldStop(32768);
try { BA.debugLineNum = 81;BA.debugLine="camEx.Initialize(Panel1, frontCamera, Me, \"Camera1\")";
Debug.ShouldStop(65536);
mostCurrent._camex._initialize(mostCurrent.activityBA,mostCurrent._panel1,_frontcamera,main.getObject(),"Camera1");
 BA.debugLineNum = 82;BA.debugLine="frontCamera = camEx.Front";
Debug.ShouldStop(131072);
_frontcamera = mostCurrent._camex._front;
 } 
       catch (Exception e49) {
			processBA.setLastException(e49); BA.debugLineNum = 84;BA.debugLine="Msgbox(\"unable open camera\", \"\")";
Debug.ShouldStop(524288);
anywheresoftware.b4a.keywords.Common.Msgbox("unable open camera","",mostCurrent.activityBA);
 };
 BA.debugLineNum = 86;BA.debugLine="End Sub";
Debug.ShouldStop(2097152);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _lvpsize_itemclick(int _position,Object _value) throws Exception{
		Debug.PushSubsStack("LvPSize_ItemClick (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
b4a.example.cameraexclass._camerasize[] _picturesizes = null;
b4a.example.cameraexclass._camerasize _ps = null;
float _ratio = 0f;
float _ratiopreview = 0f;
b4a.example.cameraexclass._camerasize[] _previewsizes = null;
Debug.locals.put("Position", _position);
Debug.locals.put("Value", _value);
 BA.debugLineNum = 202;BA.debugLine="Sub LvPSize_ItemClick (Position As Int, Value As Object)";
Debug.ShouldStop(512);
 BA.debugLineNum = 203;BA.debugLine="ClearLvs";
Debug.ShouldStop(1024);
_clearlvs();
 BA.debugLineNum = 204;BA.debugLine="Dim pictureSizes() As CameraSize = camEx.GetSupportedPicturesSizes";
Debug.ShouldStop(2048);
_picturesizes = mostCurrent._camex._getsupportedpicturessizes();Debug.locals.put("pictureSizes", _picturesizes);Debug.locals.put("pictureSizes", _picturesizes);
 BA.debugLineNum = 205;BA.debugLine="Dim ps As CameraSize = pictureSizes(Position)";
Debug.ShouldStop(4096);
_ps = _picturesizes[_position];Debug.locals.put("ps", _ps);Debug.locals.put("ps", _ps);
 BA.debugLineNum = 207;BA.debugLine="camEx.StopPreview";
Debug.ShouldStop(16384);
mostCurrent._camex._stoppreview();
 BA.debugLineNum = 208;BA.debugLine="camEx.SetPreviewSize(ps.Width, ps.Height)";
Debug.ShouldStop(32768);
mostCurrent._camex._setpreviewsize(_ps.Width,_ps.Height);
 BA.debugLineNum = 209;BA.debugLine="camEx.SetPictureSize(ps.Width, ps.Height)";
Debug.ShouldStop(65536);
mostCurrent._camex._setpicturesize(_ps.Width,_ps.Height);
 BA.debugLineNum = 210;BA.debugLine="camEx.CommitParameters";
Debug.ShouldStop(131072);
mostCurrent._camex._commitparameters();
 BA.debugLineNum = 214;BA.debugLine="Dim ratio As Float";
Debug.ShouldStop(2097152);
_ratio = 0f;Debug.locals.put("ratio", _ratio);
 BA.debugLineNum = 215;BA.debugLine="Dim ratioPreview As Float";
Debug.ShouldStop(4194304);
_ratiopreview = 0f;Debug.locals.put("ratioPreview", _ratiopreview);
 BA.debugLineNum = 217;BA.debugLine="Dim previewSizes() As CameraSize = camEx.GetSupportedPreviewSizes";
Debug.ShouldStop(16777216);
_previewsizes = mostCurrent._camex._getsupportedpreviewsizes();Debug.locals.put("previewSizes", _previewsizes);Debug.locals.put("previewSizes", _previewsizes);
 BA.debugLineNum = 220;BA.debugLine="camEx.SetPreviewSize(previewSizes(fittingpreviewSizes(Position)).Width , previewSizes(fittingpreviewSizes(Position)).Height)";
Debug.ShouldStop(134217728);
mostCurrent._camex._setpreviewsize(_previewsizes[_fittingpreviewsizes[_position]].Width,_previewsizes[_fittingpreviewsizes[_position]].Height);
 BA.debugLineNum = 221;BA.debugLine="camEx.CommitParameters";
Debug.ShouldStop(268435456);
mostCurrent._camex._commitparameters();
 BA.debugLineNum = 227;BA.debugLine="ratio = ps.Height /ps.Width  'en gros 3/4 ou 0,56";
Debug.ShouldStop(4);
_ratio = (float) (_ps.Height/(double)_ps.Width);Debug.locals.put("ratio", _ratio);
 BA.debugLineNum = 229;BA.debugLine="btnPictureSize.Text = ps.width &\"x\"& ps.height";
Debug.ShouldStop(16);
mostCurrent._btnpicturesize.setText((Object)(BA.NumberToString(_ps.Width)+"x"+BA.NumberToString(_ps.Height)));
 BA.debugLineNum = 230;BA.debugLine="If ratio < (100%x / 100%y) Then 'crop largeur de panel  (ratio = 3/4 et y = 5 x =3 env)";
Debug.ShouldStop(32);
if (_ratio<(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA)/(double)anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA))) { 
 BA.debugLineNum = 231;BA.debugLine="Panel1.Width =   100%y / ratio";
Debug.ShouldStop(64);
mostCurrent._panel1.setWidth((int) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA)/(double)_ratio));
 BA.debugLineNum = 232;BA.debugLine="Panel1.Height = 100%y";
Debug.ShouldStop(128);
mostCurrent._panel1.setHeight(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA));
 BA.debugLineNum = 233;BA.debugLine="Panel1.left = Abs((100%x - Panel1.width)/2)";
Debug.ShouldStop(256);
mostCurrent._panel1.setLeft((int) (anywheresoftware.b4a.keywords.Common.Abs((anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA)-mostCurrent._panel1.getWidth())/(double)2)));
 }else {
 BA.debugLineNum = 235;BA.debugLine="Panel1.Width = 100%x";
Debug.ShouldStop(1024);
mostCurrent._panel1.setWidth(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA));
 BA.debugLineNum = 236;BA.debugLine="Panel1.Height = 100%x / ratio";
Debug.ShouldStop(2048);
mostCurrent._panel1.setHeight((int) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA)/(double)_ratio));
 BA.debugLineNum = 238;BA.debugLine="Panel1.top = Abs((100%y - Panel1.height)/2)";
Debug.ShouldStop(8192);
mostCurrent._panel1.setTop((int) (anywheresoftware.b4a.keywords.Common.Abs((anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA)-mostCurrent._panel1.getHeight())/(double)2)));
 };
 BA.debugLineNum = 241;BA.debugLine="camEx.StartPreview";
Debug.ShouldStop(65536);
mostCurrent._camex._startpreview();
 BA.debugLineNum = 243;BA.debugLine="Log (\"panel1 wxh \" & Panel1.Width & \"x\" & Panel1.Height )";
Debug.ShouldStop(262144);
anywheresoftware.b4a.keywords.Common.Log("panel1 wxh "+BA.NumberToString(mostCurrent._panel1.getWidth())+"x"+BA.NumberToString(mostCurrent._panel1.getHeight()));
 BA.debugLineNum = 244;BA.debugLine="Log(camEx.GetPreviewSize)";
Debug.ShouldStop(524288);
anywheresoftware.b4a.keywords.Common.Log(BA.ObjectToString(mostCurrent._camex._getpreviewsize()));
 BA.debugLineNum = 247;BA.debugLine="End Sub";
Debug.ShouldStop(4194304);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 31;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 32;BA.debugLine="Private frontCamera As Boolean = False";
_frontcamera = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 33;BA.debugLine="Dim WS As PhoneWakeState";
_ws = new anywheresoftware.b4a.phone.Phone.PhoneWakeState();
 //BA.debugLineNum = 34;BA.debugLine="Dim PictureProgress As Boolean";
_pictureprogress = false;
 //BA.debugLineNum = 36;BA.debugLine="Dim fittingpreviewSizes() As Int 'on stocke l'index previewsize  corrrespondant à l'aspect ratio de l'image";
_fittingpreviewsizes = new int[(int) (0)];
;
 //BA.debugLineNum = 37;BA.debugLine="fittingpreviewSizes = Array As Int(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)";
_fittingpreviewsizes = new int[]{(int) (0),(int) (0),(int) (0),(int) (0),(int) (0),(int) (0),(int) (0),(int) (0),(int) (0),(int) (0),(int) (0),(int) (0),(int) (0),(int) (0),(int) (0),(int) (0)};
 //BA.debugLineNum = 38;BA.debugLine="End Sub";
return "";
}
}
